﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PngToIco
{
	public partial class MainForm : Form
	{
		public MainForm()
		{
			InitializeComponent();

			this.TopMost = true;
		}

		private Icon ConvertToIcon(Image image)
		{
			//Image resizedImage = image.GetThumbnailImage(64, 64, null, new IntPtr());
			//Bitmap bitmap = new Bitmap(resizedImage);
			//bitmap.MakeTransparent(Color.FromArgb(0, 255, 0));
			//bitmap.SetResolution(64, 64);
			//Icon icon = Icon.FromHandle(bitmap.GetHicon());

			//return icon;

			Bitmap bitmap = new Bitmap(image);
			bitmap.MakeTransparent(Color.FromArgb(0, 255, 0));
			Bitmap resized = new Bitmap(bitmap, new Size(256, 256));
			resized.SetResolution(256, 256);
			Icon icon = Icon.FromHandle(resized.GetHicon());

			return icon;
		}

		private void DoWork()
		{
			try
			{
				OpenFileDialog openDlg = new OpenFileDialog();
				openDlg.Filter = "Image|*.bmp;*.jpg;*.jpeg;*.png;|All|*.*";
				if (openDlg.ShowDialog() != DialogResult.OK)
					return;

				string filePath = openDlg.FileName;
				Image image = Image.FromFile(filePath);
				Icon icon = ConvertToIcon(image);

				string iconFilePath = Path.ChangeExtension(filePath, "ico");
				using (FileStream fs = File.OpenWrite(iconFilePath))
					icon.Save(fs);

				Process.Start(Path.GetDirectoryName(iconFilePath));
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
		}

		private void loadButton_Click(object sender, EventArgs e)
		{
			DoWork();

			GC.Collect();
		}
	}
}
